import numpy as np
import scipy.sparse as sp
from scipy.sparse.linalg import spsolve
from scipy.sparse import spmatrix
import matplotlib.pyplot as plt
import matplotlib.animation as animation

import mesh
from darcy_1D import getmatrhs1D


def time_loop(mesh, K, bcfunc, rhsfun, t0, tf, dt, theta, uinit, lineaire=True):
    t = t0
    ts = [t0]
    u = [uinit]
    uold = uinit
    while(t < tf):
        if (1.1*dt >= tf -t):
            dt = tf -t
        
        lval = theta*bcfunc(t+dt)[0]['value'] + (1-theta)*bcfunc(t)[0]['value'] 
        rval = theta*bcfunc(t+dt)[1]['value'] + (1-theta)*bcfunc(t)[1]['value']
        bcleft = {'type': bcfunc(t)[0]['type'], 'value': lval}
        bcright = {'type': bcfunc(t)[1]['type'], 'value': rval}
        bcs = [bcleft, bcright]

        if lineaire:
            unew = do_step(mesh, K, bcs, rhsfun(t+dt), dt, theta, uold)
        else:
            unew = picard(mesh, K, bcs, rhsfun(t+dt), dt, theta, uold)
 
        u.append(unew)
        t += dt
        ts.append(t)
        uold = # à faire
        
    return ts, u

def do_step(mesh, K, bclist, rhsfun, dt, theta, uold):

    A, f = getmatrhs1D(mesh, K, bclist, rhsfun)
    if theta == 0:
        unew = # à faire
    else:
        b = # à faire
        B= A.copy()
        D =A.diagonal()
        D += # à faire
        B.setdiag(D)        
        unew = #à faire
    return unew

def picard(mesh, Kfun, bclist, rhsfun, dt, theta, uold):
    converged = False
    tol =1e-5

    ukold = uold

    while not(converged):
        K = # à faire
        A, f = getmatrhs1D(mesh, K, bclist, rhsfun)
        ## Comme dans do_step, calculer uknew
        
        critere = np.max (np.abs (uknew-ukold )) / np.max(np.abs(ukold))
        #print('Critere   ', critere)
        converged = critere < tol
        ukold = ## à faire

    return uknew
    
